#!/usr/local/bin/perl

$CGIPATH = '.';

#
# contents.cgi -- list article contents.
# Copyright (C) 1996-1998 nir@mvg.biglobe.ne.jp
#
# This file is part of WebForum.
# WebForum is free script; you can redistribute it and/or modify it
# for any purpose.
#
# @(#)$Id: contents.cgi,v 1.22.1.2 1998/12/19 06:02:48 nir Exp $
#

require "$CGIPATH/forum.pl";

%http_args = &http'http_args;
$room = $http_args{'room'};
$area = $http_args{'area'};
$mode = $http_args{'mode'};
$init_mes = $http_args{'mes'};
$mode = 'onethread' if ($init_mes);
%http_cookie = &http'http_cookie;
%gui = &forum'get_gui($http_cookie{'gui'});
%ext = &forum'get_ext($http_cookie{'ext'});
$format = &forum'escape_format($gui{'listfmt'});
$indent = $gui{'indent'};
$suppress = ($gui{'suppress'} eq 'on');
$noframes = (($gui{'frame'} eq 'no') || ($http_args{'frame'} eq 'no'));
if ($noframes) {
	$option = "&frame=no";
} else {
	$target_frame = qq(\nTARGET="article");
}
$child_order = ($gui{'sort'} ne 'reverse');
$sibling_order = ($gui{'sort'} eq 'order');

$title = &forum'get_title($room);
&WarningMsg('Bad Forum') if ($title eq '');

($req_min) = $area =~ m/^(\d+)$/;
($req_min, $req_max) = $area =~ m/^(\d*)-(\d*)$/ if ($req_min eq '');
$req_max++ if ($req_max);
&get_contents($room, *req_min, *req_max);
$article_area = sprintf("(Lԍ[%d`%d])", $req_min, $req_max - 1) if ($req_min < $req_max);
$last_modified = (stat("$FORUMPATH/$room/contents"))[9];
$reload_menu = qq(<A HREF="$CGIROOT/menu.$CGI"\nTARGET="menu">${MENUICON}cI</A> ) unless ($noframes);
$new_menu = qq(<A HREF="$CGIROOT/article.$CGI?room=$room$option"$target_frame>${NEWICON}VKLe</A> );
$page_size = $req_max - $req_min;
$overlap = $gui{'overlap'};
$overlap = int($page_size / 2) if ($overlap > $page_size / 2);
$contents_area = "$CGIROOT/contents.$CGI?room=$room$option";
$contents_base = $contents_area;
$contents_base .= "&area=$area" if ($area ne '');
if ($mode eq 'date') {
	$mode_menu = qq{<A HREF="$contents_base">$THREADICON</A>|};
} elsif ($mode ne 'onethread') {
	$mode_menu = qq{<A HREF="$contents_base&mode=date">$DATEICON</A>|};
}
$contents_area .= "&mode=$mode" if ($mode ne '');
$contents_area .= "&area=";
if ($sibling_order) {
	$top_icons = &prev_page($TOPICON, $PREVICON, $WIDEICON);
	$bot_icons = &next_page($BOTICON, $NEXTICON, $WIDEICON);
} else {
	$top_icons = &next_page($TOPICON, $PREVICON, $WIDEICON);
	$bot_icons = &prev_page($BOTICON, $NEXTICON, $WIDEICON);
}
$help = &forum'help('contents');
$line_extensions = &forum'make_extensions('contents', '', "\n", $noframes, *ext);
$icon_extensions = &forum'make_extensions('icon', '', '|', $noframes, *ext);

$output = sprintf("Content-Type: text/html\n%s\n%s\n\n",
		&forum'last_modified($last_modified),
		&forum'expires(time + $forum'expires));
$output .= <<"EOL";
<HTML>
<HEAD><TITLE>$FORUMTITLE ($title)</TITLE></HEAD>
$BODY
<H1><A HREF="$FORUMROOT/$room/"$target_frame>$title</A>ꗗ
$help</H1>
$line_extensions<PRE>
EOL

$output .= "${mode_menu}${icon_extensions}${reload_menu}${new_menu}${top_icons}${article_area}<HR>";
&put_contents;
$output .= "<HR>${mode_menu}${icon_extensions}${reload_menu}${new_menu}${bot_icons}${article_area}</PRE>\n";
$output .= "$FOOTER" if ($noframes);
$output .= "</BODY>\n</HTML>\n";

&forum'convert_print(*output);

exit(0);

sub prev_page {
	local($page);
	local(@icons) = @_;

	return('') if ($req_min <= $min_mes);
	$page .= &get_page($icons[0], $min_mes, $min_mes + $page_size);
	$page .= &get_page($icons[1], $req_min - $page_size + $overlap, $req_min + $overlap);
	$page .= &get_page($icons[2], $req_min - $gui{'articles'}, $req_max);
	return("$page ");
}

sub next_page {
	local($page);
	local(@icons) = @_;

	return('') if ($req_max >= $max_mes);
	$page .= &get_page($icons[0], $max_mes - $page_size, $max_mes);
	$page .= &get_page($icons[1], $req_max - $overlap, $req_max + $page_size - $overlap);
	$page .= &get_page($icons[2], $req_min, $req_max + $gui{'articles'});
	return("$page ");
}

sub get_page {
	local($icon, $min, $max) = @_;

	&get_area(*min, *max);
	sprintf('<A HREF="%s%d-%d">%s</A>', $contents_area, $min, $max - 1, $icon);
}

sub get_area {
	local($size);
	local(*min, *max) = @_;

	$size = $max - $min;
	$size = $max_mes - $min_mes if (($size <= 0) && ($mode eq 'onethread'));
	$size = $gui{'articles'} if ($size <= 0);
	$size = $max_mes - $min_mes if (($size <= 0) || ($size > $max_mes - $min_mes));
	$max = ($min) ? $min + $size : $max_mes unless ($max);
	$min = $max - $size;
	if ($min < $min_mes) {
		$max += $min_mes - $min;
		$min = $min_mes;
	}
	if ($max > $max_mes) {
		$min -= $max - $max_mes;
		$max = $max_mes;
	}
}

sub get_contents {
	local($mes, $ref, $passwd, $from, $subject, $sibling, $premes);
	local($sec, $min, $hour, $mday, $mon, $year);
	local($room, *req_min, *req_max) = @_;

	open(CONTENTS, "$FORUMPATH/$room/contents") || &ErrorMsg('missing', "$room/contents");
	$_ = <CONTENTS>;
	chop;
	($min_mes, $max_mes) = /^(\d{5}) (\d{5}) \S{3,}$/;
	&ErrorMsg('format', "$room/contents") unless (($min_mes) && ($max_mes) && ($min_mes <= $max_mes));
	&get_area(*req_min, *req_max);
	$premes = 0;
	while (<CONTENTS>) {
		chop;
		($mes, $ref, $passwd, $year, $mon, $mday, $hour, $min, $sec, $from, $subject)
			= m#^(\d{5}) (\d{5}) (\S{3,}) (\d{4})/(\d{2})/(\d{2}) (\d{2}):(\d{2}):(\d{2}) <(.+)> (.+)$#;
		&ErrorMsg('format', "$room/contents") if ($mes <= $premes);
		$premes = $mes;
		next if (($mes < $req_min) || ($mes >= $req_max));
		$ref{$mes} = $ref;
		$ref = '00000' if (($ref < $req_min) || ($ref >= $mes) || ($mode eq 'date'));
		if ($passwd =~ /^\*+$/) {
			$from = '****';
			$subject = '**** VXeǗ҂ɂLZ';
			$suppress{$mes} = $suppress;
		} elsif ($passwd =~ /^\++$/) {
			$from = '****';
			$subject = '**** e҂ɂLZ';
			$suppress{$mes} = $suppress;
		}
		($from{$mes}, $subject{$mes}) = ($from, $subject);
		$year -= 1900;
		$mon -= 1;
		$mtime{$mes} = -1;
		if (&forum'datetime_check($sec, $min, $hour, $mday, $mon, $year)) {
			$mtime{$mes} = &timelocal($sec, $min, $hour, $mday, $mon, $year) - $http'local_adj;
		}
		
		if (! $child{$ref}) {
			$child{$ref} = $mes;
		} elsif ($sibling_order) {
			$sibling = $child{$ref};
			while ($sibling{$sibling}) {
				$sibling = $sibling{$sibling};
			}
			$sibling{$sibling} = $mes;
		} else {
			$sibling{$mes} = $child{$ref};
			$child{$ref} = $mes;
		}
	}
	close(CONTENTS);
}

sub put_contents {
	local($mes, $sibling);

	$lines = 0;
	if ($mode eq 'onethread') {
		$sibling{'00000'} = 0;
		foreach $mes (split(/,/, $init_mes)) {
			$mes = sprintf("%05d", $mes);
		next if (($mes < $req_min) || ($mes >= $req_max));
			while (($ref{$mes} >= $req_min) && ($ref{$mes} < $req_max)) {
				$mes = $ref{$mes};
			}
			for ($sibling = '00000'; $sibling{$sibling} != $mes; $sibling = $sibling{$sibling}) {
				unless ($sibling{$sibling}) {
					$sibling{$sibling} = $mes;
					$sibling{$mes} = 0;
					last;
				}
			}
		}
		$mes = $sibling{'00000'};
	} else {
		$mes = $child{'00000'};
	}
	&article("$mes", 0) if ($mes);
	if ($lines == 0) {
		$output .= ($mes) ? 'I͈͂ɂ' : '̉cɂ';
		$output .= 'ЂƂL܂B';
	}
}

sub article {
	local($mes, $level) = @_;

	for (;;) {
		&article_out("$mes", $level) if ($child_order);
		&article("$child{$mes}", $level + 1) if ($child{$mes});
		&article_out("$mes", $level) unless ($child_order);
	last unless ($sibling{$mes});
		$mes = $sibling{$mes};
	}
}

sub article_out {
	local($I, $i, $s);
	local($mes, $level) = @_;

	return if ($suppress{$mes});
	$output .= "\n" if ($lines++);
	$I = ($level >= $indent) ? sprintf("%${indent}d", $level) : ' 'x$level;
	$i = ($mtime{$mes} > $^T - $forum'new) ? $NEWTEXTICON : $TEXTICON;
	$s = sprintf(qq(<A HREF="%s/%s/%05d.html"%s>%s</A>),
		$FORUMROOT, $room, $mes, $target_frame, $subject{$mes});
	$output .= &forum'eval_var($format, 'NnRrIifsYymdHMS', $mtime{$mes}, $mes, $ref{$mes}, $I, $i, $from{$mes}, $s);
}

